var crypto = require('crypto'),
    fs = require('fs'),
    path = require('path'),
    Hand = require('./error_hand'),
    config = {
        cryptkey: crypto.createHash('sha256').update('bin').digest(),
        iv: 'E4WXqn_IotaTPN6E',
        alg: 'aes-256-ctr',
        header: 'JQL1'
    };

function encrypt(a) {
    var b = crypto.createCipheriv(config.alg, config.cryptkey, config.iv),
        c = config.header + b.update(a, 'utf8', 'binary');
    return c += b.final('binary'), c
}

function decrypt(a) {
    if (null === a || 'undefined' == typeof a || '' === a) return a;
    var b = crypto.createDecipheriv(config.alg, config.cryptkey, config.iv),
        c = b.update(a.slice(config.header.length), 'binary', 'utf8');
    return a.slice(0, config.header.length) == config.header ? (c += b.final('utf8'), c) : {
        code: '5689',
        message: 'Cannot Open Database File'
    }
}

function Token(a) {
    this.length = a;
    for (var b = '0123456789abcdefg_hijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ', c = '', d = a; 0 < d; --d) c += b[Math.floor(Math.random() * b.length)];
    return c
}

function ExportFile(a, b) {
    try {
        return fs.writeFileSync(a, b), !0
    } catch (c) {
        return !1
    }
}

function ImportFile(a, b) {
    return fs.existsSync(a) ? fs.readFileSync(a, b) : {
        code: '3',
        message: 'Cannot Open File'
    }
}

function Deletefile(a, b, c) {
    if (fs.existsSync(a + '/' + b + c)) fs.unlinkSync(a + '/' + b + c);
    else return !1;
    return !0
}

function Deletefolder(a) {
    if (fs.existsSync(a)) return fs.readdirSync(a).forEach(function (b) {
        var d = a + '/' + b;
        fs.lstatSync(d).isDirectory() ? deleteFolderRecursive(d) : fs.unlinkSync(d)
    }), fs.rmdirSync(a), !0
}

function Listfolder(a) {
    var b = [];
    return fs.readdirSync(a).forEach(c => {
        var d = fs.statSync(a + c);
        d.isDirectory() && b.push(c)
    }), b
}

function Listfile(a) {
    var b = [];
    return CheckFile(a) ? (fs.readdirSync(a).forEach(c => {
        var d = c.substring(c.length + 1, c.lastIndexOf('.')).toLowerCase();
        if ('.jsq' == d) {
            var e = c.match(/([^\\/]+?)(?:\.[^\.\\/]*)?$/)[1];
            b.push(e)
        }
    }), b) : Hand.Error('w0xjs07', 'file')
}

function Createfolder(a) {
    return fs.mkdirSync(a), !0
}

function CheckFile(a) {
    return !!fs.existsSync(a)
}

function RenameFile(a, b) {
    return !!fs.existsSync(a) && (fs.renameSync(a, b), !0)
}
module.exports = {
    Token: Token,
    encrypt: encrypt,
    decrypt: decrypt,
    ExportFile: ExportFile,
    ImportFile: ImportFile,
    Check: CheckFile,
    List: Listfolder,
    ListTBL: Listfile,
    CreateDB: Createfolder,
    DeleteDB: Deletefolder,
    DeleteTBL: Deletefile,
    Rename: RenameFile
};