# Mira Database Server 

[![NPM version][npm-image]][npm-url]
[![NPM downloads][downloads-image]][downloads-url]
[![Try mira-db on RunKit](https://badge.runkitcdn.com/mira-db.svg)](https://npm.runkit.com/mira-db)
[![Slack Status](https://img.shields.io/badge/slack-Nodeclient-blue.svg?longCache=true&style=flat)](https://nodeclient.slack.com)
[![Known Vulnerabilities](https://snyk.io/test/npm/mira-db/badge.svg)](https://snyk.io/test/npm/mira-db)

Mira-DB local & remote json database server

![news](https://raw.githubusercontent.com/Nodeclient/Mira-DB/master/banner.jpg)

## Install (global)
```
npm install mira-db --global
```

## Mira Source Example

* [GITHUB](https://github.com/Nodeclient/Mira-DB) - EXAMPLE Projects
* [HELP](https://github.com/Nodeclient/Mira-DB/tree/master/HELP%20DOCS) - EXPLAIN Querys
* [YOUTUBE](https://www.youtube.com/watch?v=wWt-ZyinFdM&list=PLq4qcUhhlBq4nsD4oVym8jz1WwKCFlDx1) - TUTORIAL mira

## Mira Query Statements

        UNIQUE COLUMN <COLUMN_NAME> TABLE <TABLE_NAME>;
        SELECT TABLE <TABLE_NAME>; 
        SELECT TABLE <TABLE_NAME> COUNT; 
        SELECT TABLE <TABLE_NAME> COLUMN ["COL1"];
        SELECT TABLE <TABLE_NAME> LIMIT ["0","10"];
        SELECT TABLE <TABLE_NAME> COLUMN ["COL1"] FIND ["SEARCH_STRING"]; 
        UPDATE ROW <TABLE_NAME> COLUMN ["COL1","COL2",..] VALUE ["VAL1","VAL2"] FIND ["COL1","SEARCH_STRING"];
        ADD ROW <TABLE_NAME> COLUMN ["COL1","COL2","COL3"] VALUE ["VAL1","VAL2","VAL3"]; 
        ADD COLUMN ["COL1","COL2","COL3"] TABLE <TABLE_NAME>; 
        RENAME TABLE ["TABLE"] VALUE ["NEW_NAME"]; 
        RENAME DATABASE ["DATABASE_NAME"] VALUE ["NEW_NAME"]; 
        RENAME COLUMN ["COL1","COL2"] TABLE <TABLE_NAME> VALUE ["NEW_1","NEW_2"]; 
        DELETE COLUMN <COLUMN_NAME> TABLE <TABLE_NAME>; 
        DELETE ROW <TABLE_NAME> COLUMN <COLUMN_NAME> VALUE ["STRING"];
        DELETE ROW <TABLE_NAME> INDEX <INDEX_NUMBER>;
        CREATE TABLE <TABLE_NAME> COLUMN ["COL1","COL2","COL3"] VALUE ["VAL1","VAL2","VAL3"];
        CREATE DATABASE <DATABASE_NAME>;
        DROP DATABASE <DATABASE_NAME>;
        DROP TABLE <TABLE_NAME>;
        LIST DATABASE;
        LIST TABLE <DATABASE_NAME>;

## Nodejs  >  custom_server.js

easy integrate with your existing systems (express,socket.io,python,visual studio,nwjs,http,react,unity5,etc..)

```js
    // INCLUDE MIRA
    const mira = require("mira-db");
    // SET YOUR USER PERMISSION
    var perms = { UNIQUE:true,SELECT:true,ADD:true,UPDATE:true,RENAME:true,DROP:true,DELETE:true,CREATE:true,LIST:true }
    // YOUR STORAGE FOLDER
    var My_Db_folder = "/your_database_folder";
    //SELECT DATABASE
    var My_Db_name = "test";
    // CREATE NEW DATABASE OBJECT
    var mydb = new mira(My_Db_folder,"UTF-8");
    // SET QUERY
    var query = 'SELECT TABLE person';

    
    // RESULT METHOD (EXAMPLE) 1
    var result = mydb.Query(query,My_Db_name,perms);
    console.log(  result );
    
    // RESULT METHOD (EXAMPLE) 2
    mydb.Query(query,My_Db_name,perms ,function(result){
      console.log(  result );
    });           
```

## (NEW) BACKUP SYSTEM

* Install & Backup Project  : ``` npm i install-maker ```
* More Detail              		  : ``` www.npmjs.com/package/install-maker ```


#### Updates & Fixed
+ Version 1.0.22
    + added new query "DELETE INDEX"
    + added database compressing module (not active yet)
+ Version 1.0.21
    + only (readme) document some changed
    + database compressing module (coming at 1.0.22) 
	
## License

Copyright (c) 2018 Levent Inan

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

[npm-image]: https://img.shields.io/npm/v/mira-db.svg?style=flat
[npm-url]: https://npmjs.org/package/mira-db
[downloads-image]: https://img.shields.io/npm/dm/mira-db.svg?style=flat
[downloads-url]: https://npmjs.org/package/mira-db